var Modul = function() {
    this.id = false;
    this.started = false;
    this.s = {};
    this.sc = {};
    
    this.dop = 0;
    this.dol = 0;
    this.nah = 0;
    
    this.addr = '';
    this.getinprogress = false;
    this.timesinceget = 0;
    
    this.canvas = document.getElementById("mainCanvas");
    this.ctx = this.canvas.getContext('2d');
    this.ctx.translate(0,600);
    this.ctx.scale(1,-1);
    
    this.img = new Image;
    this.img.src = 'lunar_lander.png';
    
    var that = this;
    document.addEventListener("keydown", function(e){
        if (e.which == 37) {
            that.dol = 1;
        } 
        if (e.which == 38) {
            that.nah = 1;
        } 
        if (e.which == 39) {
            that.dop = 1;
        } 
        that.updateEngines();
    });
    document.addEventListener("keyup", function(e){
        if (e.which == 37) {
            that.dol = 0;
        } 
        if (e.which == 38) {
            that.nah = 0;
        } 
        if (e.which == 39) {
            that.dop = 0;
        } 
        that.updateEngines();    
    });
    
    document.getElementById("nahBtn").addEventListener("click", function(e){
        if (that.nah === 0) {
            that.nah = 1;
        } else {
            that.nah = 0;
        }
        that.updateEngines();    
    });
    document.getElementById("dolBtn").addEventListener("click", function(e){
        if (that.dol === 0) {
            that.dol = 1;
        } else {
            that.dol = 0;
        }
        that.updateEngines();    
    });
    document.getElementById("dopBtn").addEventListener("click", function(e){
        if (that.dop === 0) {
            that.dop = 1;
        } else {
            that.dop = 0;
        }
        that.updateEngines();    
    });
};
Modul.prototype.start = function() {
     this.id = false;
    this.started = false;
    this.s = {};
    this.sc = {};
    
    this.dop = 0;
    this.dol = 0;
    this.nah = 0;
    
    this.addr = '';
    this.getinprogress = false;
    this.timesinceget = 0;
    
    if (this.started === false) {
        this.addr = document.getElementById("addrInp").value;
        this.getStatus('start');
        this.renderLoop();
        
        this.started = true;
    }
};
Modul.prototype.getStatus = function(req) {
    this.timesinceget = 0;
    this.getinprogress = true;
    var xmlhttp = new XMLHttpRequest();
    var that = this;
    xmlhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            that.parseStatus(this.responseText);
            that.getinprogress = false;
        }
    };
    xmlhttp.open("GET", "ajax.php?req="+req+"&id="+this.id+"&addr="+this.addr, true);
    xmlhttp.send();
};
Modul.prototype.updateEngines = function() {
    var xmlhttp = new XMLHttpRequest();
    var that = this;
    xmlhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            //that.parseStatus(this.responseText);
        }
    };
    xmlhttp.open("GET", "ajax.php?req=engines&id="+this.id+"&addr="+this.addr+"&nah="+this.nah+"&dol="+this.dol+"&dop="+this.dop, true);
    xmlhttp.send();
    
    if (this.nah) {
        document.getElementById("nahBtn").innerHTML = "vypnout nahoru";
    } else {
        document.getElementById("nahBtn").innerHTML = "nahoru";
    }
    
    if (this.dol) {
        document.getElementById("dolBtn").innerHTML = "vypnout doleva";
    } else {
        document.getElementById("dolBtn").innerHTML = "doleva";
    }
    
    if (this.dop) {
        document.getElementById("dopBtn").innerHTML = "vypnout doprava";
    } else {
        document.getElementById("dopBtn").innerHTML = "doprava";
    }
};
Modul.prototype.parseStatus = function(jsonString) {
    json = JSON.parse(jsonString);
    console.log(json);
    if (json.continue == true) {
        this.s = json;
    }
    this.sc = json;
    this.id = json.id;
};
Modul.prototype.render = function() {
    if (this.sc.continue === true) {  
        if (!this.getinprogress) {
            this.getStatus('status');
            this.updateEngines();
        }
    }
    this.timesinceget+=1/30;
    //this.doRealPos();
    
    var k = 3;
    var s = this.s;
    var ctx = this.ctx;
    ctx.clearRect(0,0,600,600);
    //var img=document.getElementById("lunar_lander");
    ctx.drawImage(this.img, s.x*k-10*k, s.y*k-10*k, 20*k, 20*k);
    ctx.fillStyle='red';
    ctx.fillRect(s.l*k, 0, s.r*k, k);
    
    if (s.p > 15) {
        fuelcolor = 'lime';
    } else if (s.p > 8) {
        fuelcolor = 'yellow';
    } else {
        fuelcolor = 'red';
    }
    
    if (this.sc.continue == true) {
        document.getElementById("display").innerHTML = "ID: "+s.id+ "<br>x: "+s.x+"<br>y: "+s.y+"<br>vx: "+s.vx+"<br>vy: "+s.vy+
                
            "<br>palivo: "+s.p+"/20"+
            "<div style='height: 20px; width:"+Math.floor(100*s.p/20)+"px; background: "+fuelcolor+";'></div>"
            +"nahoru: "+this.nah+"<br>doleva: "+this.dol+"<br>doprava: "+this.dop;
    }
    else {
        if (this.sc.finish == true) {
            document.getElementById("display").innerHTML = "Zdar";
        } else if (this.sc.finish == false) {
            document.getElementById("display").innerHTML = "Krach";
        }
    }
};
Modul.prototype.renderLoop = function() {
    setInterval(this.render.bind(this), 1000/30);
};
Modul.prototype.doRealPos = function() {
    if (this.sc.continue == true) {
        var t = 1/30;
        this.s.x = this.s.x + this.s.vx*t + 0.5*(this.dop*6-this.dol*6)*t*t;
        this.s.y = this.s.y + this.s.vy*t + 0.5*(-7+this.nah*12)*t*t;
        this.s.vy = this.s.vy + (-7+this.nah*12)*t;

        this.s.p = this.s.p - (0.5*this.dol+0.5*this.dop + this.nah)*t;
    }
};